package javax.lang.model.util;

import java.io.Writer;
import java.util.List;
import javax.lang.model.element.Name;
import javax.lang.model.element.Element;
import javax.lang.model.element.AnnotationValue;
import javax.lang.model.element.ExecutableElement;
import java.util.Map;
import javax.lang.model.element.AnnotationMirror;
import javax.lang.model.element.TypeElement;
import javax.lang.model.element.PackageElement;

public interface Elements
{
    public abstract PackageElement getPackageElement(CharSequence p0);
    
    public abstract TypeElement getTypeElement(CharSequence p0);
    
    public abstract Map<? extends ExecutableElement, ? extends AnnotationValue> getElementValuesWithDefaults(AnnotationMirror p0);
    
    public abstract String getDocComment(Element p0);
    
    public abstract boolean isDeprecated(Element p0);
    
    public abstract Name getBinaryName(TypeElement p0);
    
    public abstract PackageElement getPackageOf(Element p0);
    
    public abstract List<? extends Element> getAllMembers(TypeElement p0);
    
    public abstract List<? extends AnnotationMirror> getAllAnnotationMirrors(Element p0);
    
    public abstract boolean hides(Element p0, Element p1);
    
    public abstract boolean overrides(ExecutableElement p0, ExecutableElement p1, TypeElement p2);
    
    public abstract String getConstantExpression(Object p0);
    
    public abstract void printElements(Writer p0, Element... p1);
    
    public abstract Name getName(CharSequence p0);
    
    public abstract boolean isFunctionalInterface(TypeElement p0);
}
